﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Net;
using System.IO;
using System.Xml;

namespace Cesticky
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void destinationTextbox_Leave(object sender, EventArgs e)
        {
            try
            {
                new Uri("http://" + destinationTextbox.Text);
            }
            catch (Exception ex) {
                MessageBox.Show("Zadaná adresa serveru není ve správném tvaru. Neprefixujte ji prosím s http://.\nChyba: " + ex.Message);
                destinationTextbox.Focus();
                destinationTextbox.SelectAll();
            }
        }

        MapTilesContainer mapBorder;

        private void button1_Click(object sender, EventArgs e)
        {
           
        }


        private Point dragStart = new Point(-1, -1);
        private void mapCanvas_MouseDown(object sender, MouseEventArgs e)
        {
            dragStart = e.Location;
        }

        private void mapCanvas_MouseUp(object sender, MouseEventArgs e)
        {
            int targetX = 0;

            if (e.Location.X > dragStart.X)
            {
                targetX = mapBorder.Location.X + (e.Location.X - dragStart.X);
            }
            else {
                targetX = mapBorder.Location.X - (int)Math.Abs(e.Location.X - dragStart.X);
            }

            int targetY = 0;

            if (e.Location.Y > dragStart.X)
            {
                targetY = mapBorder.Location.Y + (e.Location.Y - dragStart.Y);
            }
            else
            {
                targetY = mapBorder.Location.Y - (int)Math.Abs(e.Location.Y - dragStart.Y);
            }

            this.mapBorder.Location = new Point(targetX, targetY);
        }

        private void mapCanvas_MouseMove(object sender, MouseEventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Maximized;

            mapBorder = new MapTilesContainer();
            mapBorder.Location = new Point(0, 0);
            mapBorder.Size = new Size(1, 1);
            mapBorder.BackColor = Color.White;

            mapBorder.MouseUp += mapCanvas_MouseUp;
            mapBorder.MouseDown += mapCanvas_MouseDown;
            mapBorder.MouseMove += mapCanvas_MouseMove;

            this.mapCanvas.Controls.Add(mapBorder);
        }

        public int GetZoomMultiplier()
        {
            return (int)Math.Pow(2, (int)zoomUpDown.Value);
        }

        private void connectButton_Click(object sender, EventArgs e)
        {
            foreach (Control c in mapBorder.Controls)
            {
                c.Dispose();
            }

            mapBorder.Controls.Clear(); // vymazeme vsechny doposud nahrane kousky mapy
            jumpingGroupbox.Enabled = false;

            int zoomMult = GetZoomMultiplier(); // vraci 2 ^ zoom
            int tilesX = 3 * zoomMult;
            int tilesY = 2 * zoomMult;
            int tilesTotal = tilesX * tilesY;

            mapBorder.Width = tilesX * 256; // nastavime velikost posuvneho elementu tak, aby se vse veslo
            mapBorder.Height = tilesY * 256;

            int tilesDone = 0;
            int tilesTenPercent = (int)Math.Floor(tilesTotal / 10.0);
            int tilesNextMilestone = tilesTenPercent;

            loadingProgressBar.Maximum = tilesTotal;
            loadedSoFarLabel.Text = "generuji formulář..";

            for (int y = 0; y < tilesY; y++)
            {
                for (int x = 0; x < tilesX; x++)
                {
                    mapBorder.AddTile(x, y, new Uri("http://" + destinationTextbox.Text.TrimEnd('/') + "/" + zoomUpDown.Value + "/" + x + "/" + y + ".jpg"));
                    tilesDone++;

                    if (tilesDone >= tilesNextMilestone) // kazdych deset procent aktualizujeme progressbar, at jde videt, ze jsme se nekousli
                    {
                        loadingProgressBar.Value = tilesDone;
                        tilesNextMilestone += tilesNextMilestone;
                        Application.DoEvents();
                    }
                }
            }

            loadedSoFarLabel.Text = "0";
            totalLoadNumLabel.Text = "" + tilesTotal;
            loadingProgressBar.Maximum = tilesTotal;

            mapBorder.LoadTiles(); // povolime nahravani tilu, jakmile jsou vsechny nastaveny

            skokXUpDown.Maximum = tilesX;
            skokYUpDown.Maximum = tilesY;

            if (skokXUpDown.Value > skokXUpDown.Maximum)
            {
                skokXUpDown.Value = skokXUpDown.Maximum;
            }

            if (skokYUpDown.Value > skokYUpDown.Maximum)
            {
                skokYUpDown.Value = skokYUpDown.Maximum;
            }

            LoadObce();

            jumpingGroupbox.Enabled = true;
        }

        private void jumpToCoordinatesBtn_Click(object sender, EventArgs e)
        {
            int targetX = (int)skokXUpDown.Value * 256;
            int targetY = (int)skokYUpDown.Value * 256;

            int halfW = mapCanvas.Width / 2;
            int halfH = mapCanvas.Height / 2;

            mapBorder.Location = new Point(-targetX + halfW - 128, -targetY + halfH - 128);
        }

        public class Obec
        {
            public string Name;
            public long MaxZoomX;
            public long MaxZoomY;
            public long RealX, RealY;
            public long RelativeX, RelativeY;

            public Obec(string name, long x, long y)
            {
                RealX = (x / 9) * 2;
                RealY = (y / 9) * 2;

                MaxZoomX = x / 256;
                MaxZoomY = y / 256;

                RelativeX = x % 256;
                RelativeY = y % 256;

                this.Name = name;
            }

            public Point GetPoint(int zoom)
            {
                long x_ = RealX / (1536 * 256);
                long y_ = RealY / (1024 * 256);

                long x = x_ * 3 * (long)Math.Pow(2, zoom) * 256;
                long y = y_ * 2 * (long)Math.Pow(2, zoom) * 256;

                Debug.WriteLine("{0}, {1}", x, y);

                return Point.Empty;
                //return new Point(GetTile(MaxZoomX, zoom) * 256 + (int)RelativeX, GetTile(MaxZoomY, zoom) * 256 + (int)RelativeY);
            }

            /*public int GetTile(long max, int zoom)
            {
                int a = (int)max / (int)Math.Pow(2, 9);
                int b = (int)Math.Pow(2, zoom);

                return a * b;
            }*/
        }

        private List<Obec> Obce;

        public void LoadObce()
        {
            obceCombobox.Items.Clear();

            XmlTextReader r = new XmlTextReader("http://" + this.destinationTextbox.Text.TrimEnd('/') + "/obce.xml");
            this.Obce = new List<Obec>();
            while (r.Read())
            {
                if (r.IsStartElement("obec"))
                {
                    try {
                        Obce.Add(new Obec(r.GetAttribute(0), long.Parse(r.GetAttribute(1)), long.Parse(r.GetAttribute(2))));
                        obceCombobox.Items.Add(r.GetAttribute(0));
                    }
                    catch (Exception e) {
                        MessageBox.Show("Některou z obcí se nepodařilo načíst - řádek " + r.LineNumber + ".\n" + e.Message);
                    }
                }
            }
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            

            

        }

        private void button1_Click_2(object sender, EventArgs e)
        {
            var ase = from ob in Obce
                     where ob.Name.Contains("Františkovy")
                     select ob;

            foreach (Obec o in ase)
            {

                int mTileX = (int)(o.RealX / (256 * 3 * Math.Pow(2, 9))) * 2;
                int mTileY = (int)(o.RealY / (256 * 2 * Math.Pow(2, 9))) * 2;

                

                Debug.WriteLine("{0}, {1}", mTileX, mTileY);
            }
        }
    }
}
