﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;

namespace Cesticky
{
    class MapTilesContainer : Panel
    {
        public void AddTile(int x, int y, Uri address)
        {
            PictureBox pb = new PictureBox();

            pb.Width = pb.Height = 256;
            pb.Location = new Point(x * pb.Width, y * pb.Height);
            pb.InitialImage = Cesticky.Properties.Resources.loading;

            pb.MouseUp += new MouseEventHandler(pb_MouseUp);
            pb.MouseDown += new MouseEventHandler(pb_MouseDown);
            pb.MouseEnter += new EventHandler(pb_MouseEnter);
            pb.LoadCompleted += new System.ComponentModel.AsyncCompletedEventHandler(pb_LoadCompleted);
            pb.Tag = new TagData(address.ToString(), x, y);

            this.Controls.Add(pb);
        }

        void pb_MouseEnter(object sender, EventArgs e)
        {
            try
            {
                Form1 f = (Form1)this.Parent.Parent;
                PictureBox pb = (PictureBox)sender;
                TagData data = (TagData)pb.Tag;

                f.lastCoordinateLbl.Text = data.X + "," + data.Y;
            }
            catch { }
        }

        public void LoadTiles()
        {
            foreach (Control c in this.Controls)
            {
                if (c is PictureBox)
                {
                    PictureBox pb = (PictureBox)c;
                    TagData td = (TagData)pb.Tag;
                    pb.LoadAsync(td.Source);
                }
            }
        }

        void pb_LoadCompleted(object sender, System.ComponentModel.AsyncCompletedEventArgs e)
        {
            
            try
            {
                Form1 f = (Form1)this.Parent.Parent;
                int loadedNum = Int32.Parse(f.loadedSoFarLabel.Text) + 1;
                f.loadedSoFarLabel.Text = loadedNum + "";
                f.loadingProgressBar.Value = loadedNum;
            }
            catch
            {
                
            }

            //Application.DoEvents();
        }

        void pb_MouseDown(object sender, MouseEventArgs e)
        {
            this.OnMouseDown(e);
        }

        void pb_MouseUp(object sender, MouseEventArgs e)
        {
            this.OnMouseUp(e);
        }
    }

    class TagData {
        public string Source;
        public int X, Y;

        public TagData(string src, int x, int y) {
            this.Source = src;
            this.X = x;
            this.Y = y;
        }
    }
}